package OmaxBuf;
import com.cycling74.max.*;
import com.cycling74.msp.*;

/**
 * a special buffer utyilitie allowing to copy just a part of a buffer into another 
 * created on Apr, 2007 
 * @author gb
 * 
 *
 */
public class OmaxOp extends MaxObject {
	
	String bufname = null;
	
	OmaxOp(Atom[] a) {
		declareInlets(new int[]{DataTypes.ALL});
		declareOutlets(new int[]{DataTypes.ALL});
		createInfoOutlet(false);
		if (a.length>0) 
			set(a[0].toString());
	}
	
	public void set(String s) {
		bufname = s;
	}
	

	public void copySizeInto(final String destbuf) {
		MaxSystem.deferLow(new Executable() {
			public void execute() {
				long size = MSPBuffer.getSize(destbuf);
				int channels = MSPBuffer.getChannels(bufname);
				MSPBuffer.setSize(destbuf, channels, size);
				MSPBuffer.poke(destbuf, MSPBuffer.peek(bufname));
			}
		}
		);
	}

}





